# $Id: ITO.spec,v 1.7 2012/09/03 17:40:05 ksb Exp $
# $KeyFile: ${echo:-echo} sapply.ksh

%define _tmpdir			/tmp
%define _local_prefix		/usr/local
%define _local_bindir		%{_local_prefix}/bin
#NO MAN NOW%define _local_mandir	%{_local_prefix}/man/man%%X section(s)%%

# for signing of packages
#%_signature gpg
#%_gpg_name FIXME@example.org

# %dist should be defined on the target but in case it isn't we can guess one
%define distguess %(cat /etc/{redhat,fedora,suse,ubuntu}-release | sed -e 's/Fedora Core/fc@/; s/Fedora/f@/; s/Red Hat[^0-9]*\(Enterprise|Server\)*[^0-9]*/rhel@/; s/Red Hat[^0-9]*/rh/; s/.*Suse[^0-9]*/se@/; s/Ubuntu[^0-9]*/ubuntu@/; s/@[^0-9]*//;s/\([0-9][0-9]*\)[^0-9][^0-9]*\([0-9][0-9]*\)/\1_\2/; s/[^0-9]*$//')
%{!?dist:%define dist .%{distguess}}

# Do not generate debugging packages by default - older versions of rpmbuild
# (like RehHat 6.2) choke on the line with the percent in the macro name:
# We need a sed spell on RH6.x to "s/\(^.define \)%d/\1d/", Sigh. -- ksb
%define debug_package %{nil}

Name:		sapply
Version:	1.9
Release:	2%{?dist}
BuildRoot:	%{_tmpdir}/%{name}-%{version}-%{release}
Vendor:		NPCGuild.org
Summary:	NPC tool for xapply+screen
Group:		Applications/System
License:	BSD
URL:		http://patch.sac.fedex.com/RPMS
Source:		http://patch.sac.fedex.com/tarball/%{name}-%{version}.tgz
BuildRequires:	gcc m4 msrc_base install_base
# Autoreq:0 prevents misleading depencies from being generated. Normally, this
# is perfectly sane; however, the system is picking up mk directives and
# mkcmd directives as well as system depencies.
#Autoreq:	0
Requires:	/bin/ksh install_base jot screen sed perl

%description
This tool mixes xapply with screen, and opens several screens as called.

We run xapply across -Pn screens, use the present one as a status display,
unless -s is provided.  The operational model here is a little unclear, without
some comments.  We start a "slave screen" on some empty windows, if you run out
of windows we kinda puke.  Sorry.

%prep
%setup -q
%build
%install
mkdir -p %{buildroot}/%{_local_bindir}
F=`mktemp -d /tmp/bmHMXXXXXX`
mmsrc -y INTO=$F -Cauto.cf -- make DESTDIR=%{buildroot} install
rm -rf $F
find %{buildroot} -depth -type d -name OLD -exec rm -rf {} \;

%clean
# Do not confilct with the next user of the fixed-path build directory
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%{_local_bindir}/%{name}

%changelog
* Mon Sep  3 2012 KS Braunsdorf
- added logic to support installation of the mkcmd logic we include
* Wed Nov 19 2008 Ed Anderson
- Built the RPM spec file and added it to the msrc cache
